# APM for Django – Watchlog Integration

🎯 Lightweight and production-safe Application Performance Monitoring (APM) middleware for Django apps, made for [Watchlog](https://watchlog.io).

Track route execution time, status codes, and errors — and send them periodically to your Watchlog agent.

---

## 🚀 Features

- 🔧 Automatic tracking of all HTTP requests
- 📊 Aggregation of metrics by path and method
- ⚠️ Optional error tracking
- 🌐 Sends metrics to Watchlog agent over HTTP
- 💡 Safe-by-default (never crashes your app)

---

## 📦 Installation

```bash
pip install django_watchlog_apm
